<template>
  <div class="gris">
    <div style="indicaciones">
      <strong>Buscar por nombre del Gerente o nombre del Punto de venta</strong>
    </div>
    <div>
      <v-autocomplete
        v-model="gerenteSeleccionado"
        :items="gerentesData"
        item-value="id_gerente"
        item-text="nombre"
        @change="mostrarGerente()"
        solo
      />
    </div>
    <v-sheet class="mx-auto">
      <v-slide-group multiple show-arrows class="ma-0">
        <v-slide-item
          v-for="(gerente, index) in gerentes"
          :key="index"
          class="pa-5 ma-0"
        >
          <v-card
            max-width="280"
            class="pa-40 justify-center elevation-0"
            :to="gerente.to"
          >
            <v-card-subtitle class="text-center caption pt-0 pb-0"
              >Cobertura Trimestral de Certificación</v-card-subtitle
            >
            <v-card-subtitle class="text-center subtitle-1 pt-0 pb-0">{{
              gerente.territorio
            }}</v-card-subtitle>
            <div style="white-space:nowrap;overflow:hidden; align:center;justify:center">{{ gerente.nombre}}</div>
            <div style="background: #ffcd00; height: 2px"></div>
            <GraficaCircular
              :key="index"
              :name="'grafica' + gerente.id_gerente"
              :data="gerente"
            />
            <v-card-text class="text-center">
              <strong>Cobertura total:</strong>
              <br />
              <strong>{{ gerente.total_asignados }} Puntos de venta</strong>
            </v-card-text>
          </v-card>
        </v-slide-item>
      </v-slide-group>
    </v-sheet>
  </div>
</template>

<script>
import store from "@/store";
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
import GraficaCircular from "@/views/secure/certificacion-calidad/components/GraficaCircular.vue";
export default {
  name: "CoberturaGerentes003",
  props: {
    filtros: Object,
  },
  components: {
    GraficaCircular,
  },
  data() {
    return {
      gerenteSeleccionado: 0,
      gerentes: [],
      gerentesData: [],
    };
  },
  methods: {
    getCoberturaGerentes() {
      const self = this;
      let url =
        "/franquicia/dashboard/g003/secure/grafico/get/circulo/?" +
        "fechaInicial=" +
        self.filtros.fechaInicio +
        "&" +
        "fechaFin=" +
        self.filtros.fechaFin +
        "&" +
        "idNegocio=" +
        self.filtros.idNegocio;

      axios
        .get(url)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.gerentesData = data;
                let negocio = { idNegocio: self.filtros.idNegocio };
                let filtrosFechas = {
                  fechaInicio: self.filtros.fechaInicio,
                  fechaFin: self.filtros.fechaFin,
                };

                self.gerentesData.forEach((gerente) => {
                  let gerenteData = {
                    id_gerente: gerente.id_gerente,
                    nombre: gerente.nombre,
                  };

                  gerente.to = {
                    name: "certificacion_calidad_gerente_dashboard",
                    params: {
                      gerente: this.serviceCommons.objectToBase64(gerenteData), //PENDIENTE INTEGRAR WS
                      isDirector: this.serviceCommons.objectToBase64({
                        value: true,
                      }),
                      negocio: this.serviceCommons.objectToBase64(negocio), //PENDIENTE INTEGRAR WS
                      filtrosFechas: this.serviceCommons.objectToBase64(
                        filtrosFechas
                      ),
                    },
                  };
                });

                self.gerentes = self.gerentesData;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    mostrarGerente() {
      const self = this;
      self.gerentes = [];
      if (self.gerenteSeleccionado) {
        self.gerentesData.forEach((gerente) => {
          if (gerente.id_gerente === self.gerenteSeleccionado) {
            self.gerentes.push(gerente);
          }
        });
      } else {
        self.gerentes = self.gerentesData;
      }
    },
  },
  created() {
    this.getCoberturaGerentes();
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
};
</script>